<?php

require_once("binary.php");
require_once("load_macbin.php");
require_once("write_bmp.php");

set_time_limit(0);

if($argc<2){
   die("Usage: extract.php <name of graphics file> <name of program file>
E.g.: extract.php Persia(COLOR).bin \"Prince of Persia.bin\"");
}

$fn_graph=$argv[1];
$fn_prog=$argv[2];
$f_graph=load_macbin($fn_graph);
$f_prog=load_macbin($fn_prog);

//print_r($f_graph);
//die();

function unlzw($st,$ul){
print "[";
   $t=str_repeat("\x00",0x1000+$ul); $o=0x1000;
   $p=0;
   $l=strlen($st);
   while($p<$l){
      $ch=getint1($st,&$p);
      for($i=0;$i<8 && $p<$l;$i++){
         if(!($ch&1)){
            $t[$o++]=getch($st,&$p);
         }else{
            $fl1=getint1($st,&$p);
            $fl2=getint1($st,&$p);
            $r=($fl1>>4)+3;
            $s=$fl2+(($fl1&0xF)<<8);
            $a=$o-$s-1;
            for($j=0;$j<$r;$j++) $t[$o++]=$t[$a+$j];
         }
         $ch>>=1;
      }
   }
print "]";
   return substr($t,0x1000);
}

function unrle(&$f,&$p,$si,$wh){
   $out=str_repeat("\x00",$si); $o=0;
   $stk=array();
   while($o<$si){
      $c=getint1($f,$p);
      if($c>>7 and $o%$wh) $o+=$wh-$o%$wh;
      $c&=0x7F;
      if($c==0x00){
         break;
      }elseif($c>=0x01 and $c<=0x1E){
         $v=getch($f,$p); for($i=0;$i<=$c;$i++) $out[$o++]=$v;
      }elseif($c==0x1F){
         $c=getint1($f,$p)+31; $v=getch($f,$p); for($i=0;$i<=$c;$i++) $out[$o++]=$v;
      }elseif($c>=0x20 and $c<=0x3E){
       $c-=0x1F; $v=getstr($f,$p,$c); for($i=0;$i<$c;$i++) $out[$o++]=$v[$i];
      }elseif($c>=0x40 and $c<=0x5E){
         $o+=$c-0x3F;
      }elseif($c==0x5F){
         $c=getint1($f,$p)+32; $o+=$c;
      }elseif($c>=0x61 and $c<=0x7E){
         array_push($stk,array($o,$c-0x60));
      }elseif($c==0x7F){
         $c=getint1($f,$p)+31; array_push($stk,array($o,$c));
      }elseif($c==0x60){
         list($b,$n)=array_pop($stk); $l=$o-$b;
         $r=substr($out,$b,$l);
         for($i=0;$i<$n;$i++){ $out=substr_replace($out,$r,$o,$l); $o+=$l; }
      }else{
         printf("Error %02X @ %04X",$c,$p); return $out;
      }
   }
//   if($o<$si) print "Warning: Extracted data is smaller than it should be (d=".($si-$o).")\r\n";
//   if($c!=0x00) print "Warning: Extracted data is bigger than it should be\r\n";
   return $out;
}


//$arr=array(40,50,150,400,700,800,850,900,950,960,1200,1360,1750,2200,2360,2750,3750,4750,5750);
$arr=array();
foreach($f_graph["SHPD"] as $id=>$f){
   $arr[]=$id;
}

//$f=file_get_contents("pal256");
//print_r($f_prog["clut"]);
//die();
$f=$f_prog["clut"][2000];
$uk=getint4mac($f,$p);
$n=getint4mac($f,$p);
$pala=array(); for($i=0;$i<256;$i++) $pala[$i]="\x00\x00\x00\x00";
for($i=0;$i<$n;$i++){
   $x=getint2mac($f,$p);
   $r=getint2mac($f,$p); $g=getint2mac($f,$p); $b=getint2mac($f,$p);
   $pala[$x]=chr($b>>8).chr($g>>8).chr($r>>8)."\x00";
}
$pal=implode("",$pala);

mkdir("outf");

foreach($arr as $id){
   print $id."...";
//   $f=file_get_contents("PERSIA(COLOR).RSRC/SHPD/res".$id.".bin");
   $f=$f_graph["SHPD"][$id];
   $p=0; $sa=getint4mac($f,$p); $ln=getint4mac($f,$p); $ul=getint4mac($f,$p);
//   $f=file_get_contents("COLOR.dat");
   $f=$f_graph["_data"];
   $f=substr($f,$sa,$ln);
   $out=unlzw($f,$ul);
   $fp=fopen(sprintf("outf/%04d.spr",$id),"wb");
   fwrite($fp,$out);
   fclose($fp);
   $f=$out;
//   $f_t=file_get_contents("PERSIA(COLOR).RSRC/SHPT/res".$id.".bin");
   $f_t=$f_graph["SHPT"][$id];
   $q=0;
   $id0=$id;
   mkdir(sprintf("outf/%04d",$id0));
   while($q<strlen($f_t)){
      $sa=getint4mac($f_t,$q);
      if(($sa&-1)!=-1){
         print "[".$id."]";
//printf("@ %08X",$sa);
         $p=$sa;
         $wh=getint2mac($f,$p);
         $hh=getint2mac($f,$p);
         $si=$wh*$hh;
         $p+=4;
         $out=unrle($f,$p,$si,$wh);
         write_bmp(sprintf("outf/%04d/%04d.bmp",$id0,$id),$wh,$hh,$out,$pal,8,false,$wh);
      }
      $id++;
   }
   print "\r\n";
}

?>